#include <list>

#include "common.hh"
#include "Symbol.hh"
#include "Token.hh"
#include "debug.hh"
#include "SRNode.hh"
#include "RENode.hh"
#include "RETree.hh"
#include "Regex.hh"
#include "Rule.hh"

unsigned int Rule::matchInvoked = 0;

/**
 *
 */
list<SRNode*> * Rule::match(list<SRNode*> * states)
{
  ++Rule::matchInvoked;
  
  debug(8) << "Rule: " << this->toString() << "\n";
  
  list<SRNode*> * reductions = new list<SRNode*>();
  SRUnion * unified = new SRUnion(states);
  Tree * tree = new Tree(new RENode(unified));
  
  right->match(tree);
  for(RENodeI::iterator 
	i=tree->begin(), 
	z=tree->end();
      i!=z; ++i)
    {
      RENode * node = *i;
      SRNode * reduced = node->reduce(this);
      reductions->push_back(reduced);
    }
  tree->clear();
  delete tree;
  //delete unified;
  
  return reductions;
}

string Rule::toString() const
{
  return left->toString() + "=" + (modifier=='+'?"+ ":" ") + (modifier=='!'?"! ":" ") + right->toString();
}
