%{
#include <string>
#include <stdio.h>
#include <vector>
#include "Symbol.hh"
#include "common.hh"
#include "generated/cg2tree.tab.h"
int linie = 1;
%}

%s REPLACEMENT

/* regular definitions */

delim        [ \n\t]
idchar       [^\$\\\t\n\ \[\]\"\'\_\=\:\|\(\)\*\+\{\}\,\;\#\!\?\.]
id           {idchar}+

strchar      [^\"\'\n]
doublequoted \"{strchar}+\"
singlequoted \'{strchar}+\'
puncchar     [\.\,\:\;\?\!\"\'\(\)\-]
punctuation  \$.
comment      ("//"|"#").*\n
replace      \-\>
subst        \<\-

%%

<REPLACEMENT>{replace}/{id}          { BEGIN(INITIAL); return REPLACE; }
<REPLACEMENT>{replace}/"]"           { BEGIN(INITIAL); return REPLACE; }
<REPLACEMENT>{replace}/{delim}       { BEGIN(INITIAL); return REPLACE; }
{subst}/{delim}         { return SUBST; }
{subst}                 { return SUBST; }

"||"                    { return OR; }
":"                     { return ':'; }
"["                     { BEGIN(REPLACEMENT); return '['; }
"]"                     { return ']'; }
"_"                     { return '_'; }
"="                     { return '='; }
")"                     { return ')'; }
"("                     { return '('; }
"*"                     { return '*'; }
"+"                     { return '+'; }
"}"                     { return '}'; }
"{"                     { return '{'; }
","                     { return ','; }
";"                     { return ';'; }
"!"                     { return '!'; }
"?"                     { return '?'; }
"."                     { return '.'; }
{id}                    { yylval.str = new string(yytext); return ID; }
{punctuation}           { yylval.str = new string(yytext); return SINGLEQOUTED; }
{comment}               { linie++; }
{doublequoted}          { string * tmp = new string(yytext); yylval.str = new string(tmp->substr(1,tmp->length()-2)); return DOUBLEQOUTED; }
{singlequoted}          { string * tmp = new string(yytext); yylval.str = new string(tmp->substr(1,tmp->length()-2)); return SINGLEQOUTED; }
{delim}                 { if(*yytext=='\n') linie++;}
.                       { return *yytext;}

%%
